//#define NU32_STANDALONE  // uncomment if program is standalone, not bootloaded
#include "NU32.h"          // plib.h, config bits, constants, funcs for startup and UART
#define CORE_TICKS 40000000                          // 40 M ticks (one second)

void __ISR(_CORE_TIMER_VECTOR, IPL7SRS) CoreTimerISR(void) {  // step 1: the ISR
  INTClearFlag(_CORE_TIMER_IRQ);                     // clear the interrupt flag
  LATAINV = 0x20;                                    // invert pin RA5 only
  WriteCoreTimer(0);                                 // set core timer counter to 0
  _CP0_SET_COMPARE(CORE_TICKS);                      // must set CP0_COMPARE again after interrupt
}

void main(void) {
  NU32_Startup(); // cache on, min flash wait, interrupts on, LED/button init, UART init

  INTDisableInterrupts();                            // step 2: disable interrupts at CPU
  _CP0_SET_COMPARE(CORE_TICKS);                      // step 3: CP0_COMPARE register set to 40 M
  INTSetVectorPriority(_CORE_TIMER_VECTOR,7);        // step 4: interrupt priority
  INTSetVectorSubPriority(_CORE_TIMER_VECTOR,0);     // step 4: subp is 0, which is the default
  INTClearFlag(_CORE_TIMER_IRQ);                     // step 5: clear interrupt flag
  INTEnable(_CORE_TIMER_IRQ,INT_ENABLED);            // step 6: enable core timer interrupt
  INTEnableSystemMultiVectoredInt();                 // step 7: CPU enabled for mvec interrupts

  WriteCoreTimer(0);                                 // set core timer counter to 0
  while(1);                                          // infinite loop
}
