//#define NU32_STANDALONE  // uncomment if program is standalone, not bootloaded
#include "NU32.h"          // plib.h, config bits, constants, funcs for startup and UART

void __ISR(_EXTERNAL_0_VECTOR, IPL2SOFT) Ext0ISR(void) { // step 1: the ISR
  LATACLR = 0x30;                    // clear RA4 and RA5 low
  WriteCoreTimer(0);
  while(ReadCoreTimer()<10000000);   // delay for 10 M core ticks, 0.25 s
  LATASET = 0x30;                    // set pins RA4 and RA5 high
  IFS0CLR = 1 << 3;                  // clear interrupt flag IFS0<3>
}

void main(void) {
  NU32_Startup(); // cache on, min flash wait, interrupts on, LED/button init, UART init
  INTDisableInterrupts();            // step 2: disable interrupts at the CPU
  INTCONCLR = 0x1;                   // step 3: INT0 triggers on falling edge
  IPC0CLR = 0x1F << 24;              // step 4: clear the 5 pri and subpri bits
  IPC0 |= 9 << 24;                   // step 4: set priority to 2, subpriority to 1
  IFS0bits.INT0IF = 0;               // step 5: clear the interrupt flag
  IEC0SET = 1 << 3;                  // step 6: enable INT0 by setting IEC0<3>
  INTEnableSystemMultiVectoredInt(); // step 7: CPU enabled for mvec interrupts
  while(1);                          // infinite loop
}
